unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, TeEngine, Series, ExtCtrls, TeeProcs, Chart,
  TeePolar, TeeRose, TeeComma, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private declarations }
    procedure recalcAngles;
    procedure roseGetCircleLabels(Sender:TCustomPolarSeries; const Angle:Double; Index:Integer;
                                  var Text:String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Chart1.View3D:=false;
  Chart1.Legend.Visible:=false;

  with Chart1.AddSeries(TRoseSeries) as TRoseSeries do
  begin
    Pointer.Visible:=false;

    OnGetCircleLabel:=roseGetCircleLabels;
  end;

  Chart1.Axes.Visible:=false;

  TrackBar1.Max:=200;
  TrackBar1.Min:=10;
  TrackBar1.Position:=10;
  TrackBar1.Frequency:=10;
end;

procedure TForm1.recalcAngles;
var i: Integer;
begin
  with Chart1[0] as TRoseSeries do
  begin
    for i:=0 to Count-1 do
      AngleValue[i]:=i*360/Count;

    AngleIncrement:=(AngleValue[1]-AngleValue[0]) / 2;
  end;
end;

procedure TForm1.roseGetCircleLabels(Sender:TCustomPolarSeries; const Angle:Double; Index:Integer;
                                     var Text:String);
var i: Integer;
begin
  Text:='';
  with Chart1[0] as TRoseSeries do
    for i:=0 to Count-1 do
      if Angle-AngleIncrement=AngleValue[i] then
        Text:=Labels[i];
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var i: Integer;
begin
  with Chart1[0] as TRoseSeries do
  begin
    Clear;
    for i:=0 to TrackBar1.Position-1 do
      AddPolar(i, i, 'label ' + IntToStr(i));

      recalcAngles;
  end;

  Label1.Caption:='Num Values: ' + IntToStr(TrackBar1.Position);
end;

end.
